%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HttpCodes.oz ; This file is part of the MathWeb system
%
%   major updates: 30.01.2001
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   MathWeb-Project                                                        
%   AG Siekmann/FB nformatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of MathWeb, see 
%   http://www.mathweb.org/mathweb
%
% See the file "LICENSE" or
%    http://www.mathweb.org/mathweb/LICENSE.html
% for information on usage and redistribution
% of this file, and for a DISCLAIMER OF ALL
% WARRANTIES.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% This file contains the valid codes for
%% the HTTP/1.0 protocol
%%
functor

export
   codes: HttpCodes

define
% Copied from http://www.normos.org/ietf/rfc/rfc2616.txt
   
% 10.1  Informational 1xx ...........................................57
%    10.1.1   100 Continue .............................................58
%    10.1.2   101 Switching Protocols ..................................58
%    10.2  Successful 2xx ..............................................58
%    10.2.1   200 OK ...................................................58
%    10.2.2   201 Created ..............................................59
%    10.2.3   202 Accepted .............................................59
%    10.2.4   203 Non-Authoritative Information ........................59
%    10.2.5   204 No Content ...........................................60
%    10.2.6   205 Reset Content ........................................60
%    10.2.7   206 Partial Content ......................................60
%    10.3  Redirection 3xx .............................................61
%    10.3.1   300 Multiple Choices .....................................61
%    10.3.2   301 Moved Permanently ....................................62
%    10.3.3   302 Found ................................................62
%    10.3.4   303 See Other ............................................63
%    10.3.5   304 Not Modified .........................................63
%    10.3.6   305 Use Proxy ............................................64
%    10.3.7   306 (Unused) .............................................64
%    10.3.8   307 Temporary Redirect ...................................65
%    10.4  Client Error 4xx ............................................65
%    10.4.1    400 Bad Request .........................................65
%    10.4.2    401 Unauthorized ........................................66
%    10.4.3    402 Payment Required ....................................66
%    10.4.4    403 Forbidden ...........................................66
%    10.4.5    404 Not Found ...........................................66
%    10.4.6    405 Method Not Allowed ..................................66
%    10.4.7    406 Not Acceptable ......................................67
%    10.4.8    407 Proxy Authentication Required .......................67
%    10.4.9    408 Request Timeout .....................................67
%    10.4.10   409 Conflict ............................................67
%    10.4.11   410 Gone ................................................68
%    10.4.12   411 Length Required .....................................68
%    10.4.13   412 Precondition Failed .................................68
%    10.4.14   413 Request Entity Too Large ............................69
%    10.4.15   414 Request-URI Too Long ................................69
%    10.4.16   415 Unsupported Media Type ..............................69
%    10.4.17   416 Requested Range Not Satisfiable .....................69
%    10.4.18   417 Expectation Failed ..................................70
%    10.5  Server Error 5xx ............................................70
%    10.5.1   500 Internal Server Error ................................70
%    10.5.2   501 Not Implemented ......................................70
%    10.5.3   502 Bad Gateway ..........................................70
%    10.5.4   503 Service Unavailable ..................................70
%    10.5.5   504 Gateway Timeout ......................................71
%    10.5.6   505 HTTP Version Not Supported ...........................71 


   HttpCodes = {Record.map
                unit(100: "Continue"
                     101: "Switching Protocols"
                     %%    10.2  Successful 2xx"
                     200: "OK"
                     201: "Created"
                     202: "Accepted"
                     203: "Non-Authoritative Information"
                     204: "No Content"
                     205: "Reset Content"
                     206: "Partial Content"
                     %%    10.3  Redirection 3xx"
                     300: "Multiple Choices"
                     301: "Moved Permanently"
                     302: "Found"
                     303: "See Other"
                     304: "Not Modified"
                     305: "Use Proxy"
                     306: "(Unused)"
                     307: "Temporary Redirect"
                     %%    10.4  Client Error 4xx"
                     400: "Bad Request"
                     401: "Unauthorized"
                     402: "Payment Required"
                     403: "Forbidden"
                     404: "Not Found"
                     405: "Method Not Allowed"
                     406: "Not Acceptable"
                     407: "Proxy Authentication Required"
                     408: "Request Timeout"
                     409: "Conflict"
                     410: "Gone"
                     411: "Length Required"
                     412: "Precondition Failed"
                     413: "Request Entity Too Large"
                     414: "Request-URI Too Long"
                     415: "Unsupported Media Type"
                     416: "Requested Range Not Satisfiable"
                     417: "Expectation Failed"
                     %%    10.5  Server Error 5xx"
                     500: "Internal Server Error"
                     501: "Not Implemented"
                     502: "Bad Gateway"
                     503: "Service Unavailable"
                     504: "Gateway Timeout"
                     505: "HTTP Version Not Supported"
                    )
                ByteString.make}
end %define

