%%% -*- indent-tabs-mode: nil -*-
%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 2000
%%%
%%% Last change:
%%%   $Date: 2001/07/13 13:12:04 $ by $Author: afranke $
%%%   $Revision: 1.1 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%
%% HTTP requests
%%

functor

import
   Type(ask)
   URL(make toString)

export
   'class': HttpRequest

define
   /*
   fun {DropSpaces S} {List.dropWhile S Char.isSpace} end
   fun {Clear S} {Reverse {DropSpaces {Reverse {DropSpaces S}}}} end
   */
   
   VS2A  = VirtualString.toAtom
   VS2S  = VirtualString.toString
   VS2BS = VirtualString.toByteString

   /*
   %%
   %% handlers
   %%
   fun {NormalizePath CP}
      CP1 = if {IsVirtualString CP} then
               {URL.make CP}.path
            else
               {ForAll CP Type.ask.virtualString}
               CP
               %%{URL.toString url(path:CP absolute:true)}
            end
   in
      case {Reverse CP1}
      of nil|Xs then {Reverse Xs}
      else CP1 end
   end
   */
   
   %%
   %% the HttpRequest object
   %%
   class HttpRequest

      attr
         methodS:   nil
         uriS:      nil
         uriR:      unit
         protocolS: nil
         headers:   unit
         contentVS: nil

      meth init
         headers <- {NewDictionary}
      end
      meth setMethod(Method)
         methodS <- {VS2S Method}
      end
      meth getMethodS($)  @methodS end
      meth getMethodVS($) @methodS end
      meth getMethodBS($) {VS2BS @methodS} end
      meth getMethodA($)  {VS2A  @methodS} end
      %%
      meth setUri(URI)
         uriS <- {VS2S URI}
         uriR <- {URL.make URI}
      end
      meth getUriS($)  @uriS end
      meth getUriVS($) @uriS end
      meth getUriBS($) {VS2BS @uriS} end
      meth getUriR($)  @uriR end
      %%
      meth setProtocol(Protocol)
         protocolS <- {VS2S Protocol}
      end
      meth getProtocolS($)  @protocolS end
      meth getProtocolVS($) @protocolS end
      meth getProtocolBS($) {VS2BS @protocolS} end
      %%
      meth addHeader(HeaderNameVS HeaderValVS)
         HeaderNameA = {VS2A HeaderNameVS} in
         (@headers).HeaderNameA := HeaderValVS
      end
      meth condGetHeader(HeaderNameVS DefaultVal $)
         HeaderNameA = {VS2A HeaderNameVS} in
         {CondSelect @headers HeaderNameA DefaultVal}
      end
      meth getHeadersR($)
         {Dictionary.toRecord headers @headers}
      end
      meth getHeadersL($)
         {Dictionary.entries @headers}
      end
      %%
      meth setContent(VS)
         %% {Type.ask.virtualString VS}
         contentVS <- VS
      end
      /*
      meth addContent(VS)
         contentVS <- @contentVS # VS
      end
      */
      meth getContentVS($) @contentVS end
      meth getContentBS($) {VS2BS @contentVS} end
      meth getContentS($)  {VS2S  @contentVS} end
   end
   
end

