%%% -*- indent-tabs-mode: nil -*-
%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 2000
%%%
%%% Last change:
%%%   $Date: 2001/07/19 12:00:25 $ by $Author: jzimmer $
%%%   $Revision: 1.2 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%
%% some example handlers for the http server
%%

functor
   
import
   OS(tmpnam unlink)
   Pickle(save)
   URL(toString)
   
   File(loadBS)
   at 'x-ozlib://mathweb/share/File.ozf'
   
   HttpHandler('class':HTTPHandler)
   at 'x-ozlib://mathweb/httpd/HttpHandler.ozf'
   
export
   proxy:  Proxy
   dump:   DumpRequest
   applet: AppletGenerator
   
define

   %%
   %% This handler can be registered at /http/* . Requests of the form
   %%    GET /http/some.address.com/path?foo=bar
   %% will then be transformed into urls
   %%    http://some.address.com/path?foo=bar
   %% and the content retrieved from that URL will be used for the response.
   %%
   class Proxy from HTTPHandler
                  
      meth handle(UriInContext Request Connection)
         U = {URL.toString UriInContext} in
         {Connection getUrl("http:/"#U)}
      end
   end

   %%
   %% This handler simply dumps some useless info.
   %% 
   class DumpRequest from HTTPHandler
                        
      meth handle(UriInContext Request Connection)
         U = {URL.toString UriInContext} in
         {Connection ok("<HEAD></HEAD><BODY>"#U#"</BODY>")}
      end
   end

   %%
   %% This handler generates a dummy applet.
   %%
   local
      proc {PicklePack X ?BS}
         Tmp = {OS.tmpnam} in
         {Pickle.save X Tmp}
         {File.loadBS Tmp ?BS}
         {OS.unlink Tmp}
      end
   in
      class AppletGenerator from HTTPHandler
                               
         meth handle(UriInContext Request Connection)
            X = {URL.toString UriInContext}
            MsgVS = "This is an on-the-fly generated applet:\n"#X
            F = functor
                import
                   Application Tk TkTools
                define
                   {Tk.send 'bell'}
                   {Wait {New TkTools.error tkInit(text:MsgVS
                                                   aspect:1000)}.tkClosed}
                   {Application.exit 0}
                end
         in
            {Connection applet({PicklePack F})} 
         end
      end
   end
   
end



