%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 2000
%%%
%%% Last change:
%%%   $Date: 2001/07/26 09:03:55 $ by $Author: afranke $
%%%   $Revision: 1.2 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%
%% create an Oz functor from "/etc/mime.types"
%%

functor

import
   Application(getCmdArgs exit)
   Pickle(save)
   System(showError)
   
   MimeTypes at 'x-ozlib://mathweb/httpd/MimeTypes.ozf'
   
define
   AppName = 'readmimes'

   DefaultInput = "/etc/mime.types"
   DefaultOutput = "mime.types.ozf"
   
   Spec = record(inputfile(single char:&i type:string default:DefaultInput)
                 outputfile(single char:&o type:string default:DefaultOutput)
              )
   Args
   try
      Args = {Application.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end

   Rec = {MimeTypes.readFile Args.inputfile}
   
   F = functor
       export
	  mimeTypes: Rec
       end
   
   {Pickle.save F Args.outputfile}
   {Application.exit 0}
end
